## kaiming 1.0.0-ok1k0.7

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(kaiming
        DESCRIPTION "kaiming packages"
        HOMEPAGE_URL ""
        LANGUAGES CXX)

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)
set(CMAKE_INCLUDE_CURRENT_DIR ON)
set(CMAKE_BUILD_TYPE "debug")
# 安全编译选项
set(CMAKE_C_FLAGS "$ENV{CFLAGS} -O0 -g -ggdb -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fPIC -fPIE -pie -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack")
set(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O0 -g -ggdb -std=c++17 -frtti -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fPIC -fPIE -pie -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack")
# 单元测试编译选项
# set(CMAKE_C_FLAGS "$ENV{CFLAGS} -O0 -g -ggdb -fPIC -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -fprofile-arcs -ftest-coverage")
# set(CMAKE_CXX_FLAGS "$ENV{CXXFLAGS} -O0 -g -ggdb -std=c++17 -frtti -fPIC -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -fprofile-arcs -ftest-coverage")
set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -pie")
set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -pie")
set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -pie")

find_package(PkgConfig REQUIRED)
find_package(ZLIB REQUIRED)
find_package(Threads REQUIRED)
find_package(nlohmann_json 3.2.0 REQUIRED)

# 使用 REQUIRED, 如果找不到模块，命令将失败并报错，并停止运行
pkg_check_modules(GLIB2 REQUIRED glib-2.0)
pkg_check_modules(GIO2 REQUIRED gio-2.0)
pkg_check_modules(GIO_UNIX2 REQUIRED gio-unix-2.0)
pkg_check_modules(OSTREE REQUIRED ostree-1)
pkg_check_modules(DBUS REQUIRED dbus-1)
pkg_check_modules(DBUSGLIB REQUIRED dbus-glib-1)
pkg_check_modules(CURL REQUIRED libcurl)
pkg_check_modules(UUID REQUIRED uuid)  #  libuuid
pkg_check_modules(LIBELF REQUIRED libelf)

# 输出 libcurl 的库信息（可选）
message("Libcurl include directories: ${CURL_INCLUDE_DIRS}")
message("Libcurl libraries: ${CURL_LIBRARIES}")

set(LOCALEDIR "/opt/system/resource/locale")
configure_file(config.h.in config.h)

aux_source_directory(app SRC_APP)
aux_source_directory(app/builder SRC_APP_BUILDER)
aux_source_directory(app/install SRC_APP_INSTALL)
aux_source_directory(app/update SRC_APP_UPDATE)
aux_source_directory(app/upgrade SRC_APP_UPGRADE)
aux_source_directory(app/list SRC_APP_LIST)
aux_source_directory(app/info SRC_APP_INFO)
aux_source_directory(app/search SRC_APP_SEARCH)
aux_source_directory(app/repair SRC_APP_REPAIR)
aux_source_directory(app/uninstall SRC_APP_UNINSTALL)
aux_source_directory(app/enter SRC_APP_ENTER)
aux_source_directory(app/run SRC_APP_RUN)
aux_source_directory(app/ps SRC_APP_PS)
aux_source_directory(app/kill SRC_APP_KILL)
aux_source_directory(app/which SRC_APP_WHICH)
aux_source_directory(app/remoteModify SRC_APP_REMOTE)
aux_source_directory(dbus SRC_APP_DBUS)
aux_source_directory(common SRC_COMMON)

add_library(kaiming-common
    OBJECT
        ${SRC_APP_INSTALL}
        ${SRC_APP_ENTER}
        ${SRC_APP_UPDATE}
        ${SRC_APP_UPGRADE}
        ${SRC_APP_LIST}
        ${SRC_APP_SEARCH}
        ${SRC_APP_INFO}
        ${SRC_APP_REPAIR}
        ${SRC_APP_UNINSTALL}
        ${SRC_APP_RUN}
        ${SRC_APP_PS}
        ${SRC_APP_KILL}
        ${SRC_APP_WHICH}
        ${SRC_APP_REMOTE}
        ${SRC_COMMON}
)
set_target_properties(kaiming-common
    PROPERTIES
        POSITION_INDEPENDENT_CODE 1
)

add_executable(kaiming
    ${SRC_APP}
    ${SRC_APP_BUILDER}
    #${SRC_APP_ENTER}
    $<TARGET_OBJECTS:kaiming-common>
)

# 增加系统dbus
add_executable(kaiming-system-dbus
    ./dbus/gdbus/KMSystemServerAdaptor.cpp
    $<TARGET_OBJECTS:kaiming-common>
)

# 增加Session dbus
add_executable(kaiming-sessionproxy-dbus
    ./dbus/gdbus/KMSessionProxy.cpp
    ./common/KMLogger.cpp
)

# 增加SystemAsync dbus
add_executable(kaiming-systemproxy-dbus
    ./dbus/gdbus/KMSystemProxy.cpp
    ./common/KMLogger.cpp
)

add_dependencies(kaiming-system-dbus build_kmsysteminterface)
add_dependencies(kaiming-sessionproxy-dbus build_kmsessionproxy)
add_dependencies(kaiming-systemproxy-dbus build_kmsystemproxy)

target_include_directories(kaiming-common PUBLIC
    ${GLIB2_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${GIO_UNIX2_INCLUDE_DIRS}
    ${OSTREE_INCLUDE_DIRS}
    ${DBUSCPP_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${XAU_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS}
    ${LIBELF_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${nlohmann_json_INCLUDE_DIRS})

target_include_directories(kaiming PRIVATE
    ${GLIB2_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${GIO_UNIX2_INCLUDE_DIRS}
    ${OSTREE_INCLUDE_DIRS}
    ${DBUSCPP_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${XAU_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS}
    ${LIBELF_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR})

target_include_directories(kaiming-system-dbus PUBLIC
    ${GLIB2_INCLUDE_DIRS}
    ${GIO2_INCLUDE_DIRS}
    ${GIO_UNIX2_INCLUDE_DIRS}
    ${OSTREE_INCLUDE_DIRS}
    ${DBUSCPP_INCLUDE_DIRS}
    ${DBUS_INCLUDE_DIRS}
    ${XAU_INCLUDE_DIRS}
    ${CURL_INCLUDE_DIRS}
    ${LIBELF_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLIB_INCLUDE_DIRS}
)

target_include_directories(kaiming-sessionproxy-dbus PUBLIC
    ${GIO_UNIX2_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLIB_INCLUDE_DIRS}
)

target_include_directories(kaiming-systemproxy-dbus PUBLIC
    ${GIO_UNIX2_INCLUDE_DIRS}
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${GLIB_INCLUDE_DIRS}
)

target_link_libraries(kaiming-common PUBLIC
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${GIO_UNIX2_LIBRARIES}
    ${OSTREE_LIBRARIES}
    ${DBUSCPP_LIBRARIES}
    ${XAU_LIBRARIES}
    ${CURL_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${UUID_LIBRARIES}  # 链接 libuuid
    Threads::Threads
    -lstdc++fs
    ${LIBELF_LIBRARIES}
    -lelf
)

target_link_libraries(kaiming PRIVATE
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${GIO_UNIX2_LIBRARIES}
    ${OSTREE_LIBRARIES}
    ${DBUSCPP_LIBRARIES}
    ${XAU_LIBRARIES}
    ${CURL_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${UUID_LIBRARIES}
    Threads::Threads
    -lstdc++fs 
    ${LIBELF_LIBRARIES}
    -lelf
)

target_link_libraries(kaiming-system-dbus PRIVATE
    ${GLIB2_LIBRARIES}
    ${GIO2_LIBRARIES}
    ${GIO_UNIX2_LIBRARIES}
    ${OSTREE_LIBRARIES}
    ${DBUSCPP_LIBRARIES}
    ${XAU_LIBRARIES}
    ${CURL_LIBRARIES}
    ${ZLIB_LIBRARIES}
    ${UUID_LIBRARIES}
    Threads::Threads
    -lstdc++fs
    ${LIBELF_LIBRARIES}
    -lelf
    ${CMAKE_BINARY_DIR}/dbus/kmsysteminterface.a
    ${GLIB_LIBRARIES}
)

target_link_libraries(kaiming-sessionproxy-dbus PRIVATE
    ${GIO_UNIX2_LIBRARIES}
    ${CMAKE_BINARY_DIR}/dbus/kmsessionproxy.a
    ${GLIB_LIBRARIES}
)

target_link_libraries(kaiming-systemproxy-dbus PRIVATE
    ${GIO_UNIX2_LIBRARIES}
    ${CMAKE_BINARY_DIR}/dbus/kmsystemproxy.a
    ${GLIB_LIBRARIES}
)

# set(ETC_PATH "/opt/system/conf")
set(ETC_PATH "/etc")
set(LIB_PATH "/opt/system/lib")
set(USR_SHARE_PATH "/opt/system/resource")
execute_process(COMMAND dbusxx-xml2cpp ${CMAKE_CURRENT_SOURCE_DIR}/data/org.freedesktop.kaiming.xml --proxy=${CMAKE_CURRENT_SOURCE_DIR}/common/KMDbusProxy.h --adaptor=${CMAKE_CURRENT_SOURCE_DIR}/common/KMDbusAdptor.h)
# execute_process(COMMAND dbusxx-xml2cpp ${CMAKE_CURRENT_SOURCE_DIR}/dbus/kmsysteminterface.xml  --adaptor=${CMAKE_CURRENT_SOURCE_DIR}/dbus/autogenserveradaptor.h)
#execute_process(COMMAND dbusxx-xml2cpp ${CMAKE_CURRENT_SOURCE_DIR}/dbus/kmsessioninterface.xml  --adaptor=${CMAKE_CURRENT_SOURCE_DIR}/dbus/KMSessionServerAdaptor.h)

# 安装二进制到 /opt/kaiming-tools/bin
install( TARGETS kaiming
    RUNTIME DESTINATION  /opt/kaiming-tools/bin
)


# 安装二进制到 /opt/kaiming-tools/bin
install( TARGETS kaiming-system-dbus
    RUNTIME DESTINATION  /opt/kaiming-tools/bin
)

# 安装二进制到 /opt/kaiming-tools/bin
install( TARGETS kaiming-sessionproxy-dbus
    RUNTIME DESTINATION  /opt/kaiming-tools/bin
)

install( TARGETS kaiming-systemproxy-dbus
    RUNTIME DESTINATION  /opt/kaiming-tools/bin
)

# 安装 run 运行所需文件，没有则会开启 dbus 失败
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/data/
        USE_SOURCE_PERMISSIONS
        DESTINATION ${ETC_PATH}/systemd/system-environment-generators
        FILES_MATCHING PATTERN "60-kaiming"
)

# 安装 system dbus 运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kylin.kaiming.conf
        DESTINATION ${ETC_PATH}/dbus-1/system.d
)

# 安装 system dbus 运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kylin.kaiming.service
        DESTINATION ${LIB_PATH}/systemd/system
)

# 安装 session dbus 运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kaiming.session.proxy.conf
        DESTINATION ${ETC_PATH}/dbus-1/session.d
)

# 安装 session dbus systemd运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kaiming.sessionsystemd.proxy.service
        DESTINATION ${LIB_PATH}/systemd/user
)

# 安装 session dbus 运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kaiming.session.proxy.service
        DESTINATION ${USR_SHARE_PATH}/dbus-1/services
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kylin.kaiming.policy
    DESTINATION ${USR_SHARE_PATH}/polkit-1/actions
)

# 安装 session dbus 运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kaiming.system.proxy.conf
        DESTINATION ${ETC_PATH}/dbus-1/system.d
)

# 安装 session dbus systemd运行所需文件，没有则会开启 dbus 失败
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/org.kaiming.systemproxy.service
        DESTINATION ${LIB_PATH}/systemd/system
)

# 安装 XDG_DATA_DIRS 环境变量设置脚本
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/20kaiming
        DESTINATION ${ETC_PATH}/X11/Xsession.d
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/kaiming.sh
        DESTINATION ${ETC_PATH}/profile.d
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/60-kaimingenv.conf
        DESTINATION ${ETC_PATH}/ostree/ostree.conf.d
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/kaiming-system-systemd.conf
        DESTINATION ${ETC_PATH}/systemd/system.conf.d
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/data/kaiming-user-systemd.conf
        DESTINATION ${ETC_PATH}/systemd/user.conf.d
)

# 生成自启服务软链接
# execute_process(COMMAND systemctl enable org.kylin.kaiming.service)

# 安装 kaiming 命令补全脚本
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/shells/kaiming_completion.sh
        DESTINATION ${ETC_PATH}/bash_completion.d
)

# 安装 kaiming-custom.xml
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/doc/kaiming-custom.xml
        DESTINATION ${USR_SHARE_PATH}/mime/packages/
)

# execute_process(COMMAND chmod +x /etc/bash_completion.d/kaiming_completion.sh)

# 安装 kaiming 版本检查脚本
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/shells/kaiming_version.sh
        DESTINATION /opt/kaiming-tools/bin
)

install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/shells/install_files.sh
        DESTINATION /opt/kaiming-tools/bin
)

#  安装 crun 分离检查脚本
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/shells/start.sh
        PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
        DESTINATION /opt/kaiming-tools/bin
)

# 安装dbus客户端
install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/shells/dbus-cli.sh
        PERMISSIONS
        OWNER_READ OWNER_WRITE OWNER_EXECUTE
        GROUP_READ GROUP_EXECUTE
        WORLD_READ WORLD_EXECUTE
        DESTINATION /opt/kaiming-tools/bin
)

# 安装 trigger 脚本，并保留权限
# References: https://cmake.org/cmake/help/v2.8.10/cmake.html#command%3ainstall
install(DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}/shells
        USE_SOURCE_PERMISSIONS
        DESTINATION /opt/kaiming-tools/share/kaiming
        FILES_MATCHING PATTERN "*.trigger"
)

# 安装其他文件
# if(NOT EXISTS "/opt/kaiming/repo")
#     file(MAKE_DIRECTORY /opt/kaiming)
#     install(DIRECTORY data/repo DESTINATION /opt/kaiming/)
# endif()

# 设置 PO 文件和目标 MO 文件的路径
# set(POT_FILE ${CMAKE_SOURCE_DIR}/po/kaiming.pot)
set(PO_FILE ${CMAKE_SOURCE_DIR}/po/kaiming.po)
set(MO_FILE ${CMAKE_SOURCE_DIR}/po/kaiming.mo)  # 在构建目录下生成 .mo 文件

# 需要添加翻译的文件
# set(SOURCE_FILE ../app/builder/KMBuildExport.cpp) 

# # 生成pot
# add_custom_command(
#     # generate_pot

=== dbus/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.10)

# 配置生成静态库
set(XML_FILE ${CMAKE_SOURCE_DIR}/dbus/kmsysteminterface.xml)
set(GENERATED_FILE_PREFIX ${CMAKE_BINARY_DIR}/dbus/kmsysteminterface)

set(XML_FILE_SESSION ${CMAKE_SOURCE_DIR}/dbus/kmsessionproxy.xml)
set(GENERATED_FILE_PREFIX_SESSION ${CMAKE_BINARY_DIR}/dbus/kmsessionproxy)

set(XML_FILE_ASYNC ${CMAKE_SOURCE_DIR}/dbus/kmsystemproxy.xml)
set(GENERATED_FILE_PREFIX_ASYNC ${CMAKE_BINARY_DIR}/dbus/kmsystemproxy)

# 生成 kmsysteminterface 的 C 和 H 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX}.c ${GENERATED_FILE_PREFIX}.h
    COMMAND gdbus-codegen
            --interface-prefix=org.kylin.
            # --c-namespace=kaiming
            --generate-c-code=${GENERATED_FILE_PREFIX}
            ${XML_FILE}
    DEPENDS ${XML_FILE}
    COMMENT "Generating C and H files from XML using gdbus-codegen"
)

# 生成 kmsessionproxy 的 C 和 H 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_SESSION}.c ${GENERATED_FILE_PREFIX_SESSION}.h
    COMMAND gdbus-codegen
            --interface-prefix=org.kaiming.
            # --c-namespace=kaiming
            --generate-c-code=${GENERATED_FILE_PREFIX_SESSION}
            ${XML_FILE_SESSION}
    DEPENDS ${XML_FILE_SESSION}
    COMMENT "Generating C and H files from XML using gdbus-codegen for session interface"
)

# 生成 kmsystemasyncinterface 的 C 和 H 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_ASYNC}.c ${GENERATED_FILE_PREFIX_ASYNC}.h
    COMMAND gdbus-codegen
            --interface-prefix=org.kaiming.
            --generate-c-code=${GENERATED_FILE_PREFIX_ASYNC}
            ${XML_FILE_ASYNC}
    DEPENDS ${XML_FILE_ASYNC}
    COMMENT "Generating C and H files from XML using gdbus-codegen for async interface"
)

# 编译 kmsysteminterface 的 C 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX}.o
    COMMAND gcc -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fPIC -fPIE -pie -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -c ${GENERATED_FILE_PREFIX}.c
            -o ${GENERATED_FILE_PREFIX}.o
            ${GLIB_CFLAGS} ${GIO2_CFLAGS} ${GIO_UNIX2_CFLAGS}
    DEPENDS ${GENERATED_FILE_PREFIX}.c ${GENERATED_FILE_PREFIX}.h
    COMMENT "Compiling kmsysteminterface.c to kmsysteminterface.o"
)

# 编译 kmsessionproxy 的 C 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_SESSION}.o
    COMMAND gcc -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fPIC -fPIE -pie -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -c ${GENERATED_FILE_PREFIX_SESSION}.c
            -o ${GENERATED_FILE_PREFIX_SESSION}.o
            ${GLIB_CFLAGS} ${GIO2_CFLAGS} ${GIO_UNIX2_CFLAGS}
    DEPENDS ${GENERATED_FILE_PREFIX_SESSION}.c ${GENERATED_FILE_PREFIX_SESSION}.h
    COMMENT "Compiling kmsessionproxy.c to kmsessionproxy.o"
)

# 编译 kmsystemasyncinterface 的 C 文件
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_ASYNC}.o
    COMMAND gcc -fstack-protector-strong -D_FORTIFY_SOURCE=2 -fPIC -fPIE -pie -Wl,-z,relro -Wl,-z,now -Wl,-z,noexecstack -c ${GENERATED_FILE_PREFIX_ASYNC}.c
            -o ${GENERATED_FILE_PREFIX_ASYNC}.o
            ${GLIB_CFLAGS} ${GIO2_CFLAGS} ${GIO_UNIX2_CFLAGS}
    DEPENDS ${GENERATED_FILE_PREFIX_ASYNC}.c ${GENERATED_FILE_PREFIX_ASYNC}.h
    COMMENT "Compiling kmsystemproxy.c to kmsystemproxy.o"
)

# 打包 kmsysteminterface.o 到静态库 kmsysteminterface.a
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX}.a
    COMMAND ar -rc ${GENERATED_FILE_PREFIX}.a ${GENERATED_FILE_PREFIX}.o
    DEPENDS ${GENERATED_FILE_PREFIX}.o
    COMMENT "Packing kmsysteminterface.o into kmsysteminterface.a"
)

# 打包 kmsessionproxy.o 到静态库 kmsessionproxy.a
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_SESSION}.a
    COMMAND ar -rc ${GENERATED_FILE_PREFIX_SESSION}.a ${GENERATED_FILE_PREFIX_SESSION}.o
    DEPENDS ${GENERATED_FILE_PREFIX_SESSION}.o
    COMMENT "Packing kmsessionproxy.o into kmsessionproxy.a"
)

# 打包 kmsystemasyncinterface.o 到静态库 kmsystemasyncinterface.a
add_custom_command(
    OUTPUT ${GENERATED_FILE_PREFIX_ASYNC}.a
    COMMAND ar -rc ${GENERATED_FILE_PREFIX_ASYNC}.a ${GENERATED_FILE_PREFIX_ASYNC}.o
    DEPENDS ${GENERATED_FILE_PREFIX_ASYNC}.o
    COMMENT "Packing kmsystemproxy.o into kmsystemproxy.a"
)

# 定义目标，依赖生成的静态库
add_custom_target(build_kmsysteminterface DEPENDS ${GENERATED_FILE_PREFIX}.a)
add_custom_target(build_kmsessionproxy DEPENDS ${GENERATED_FILE_PREFIX_SESSION}.a)
add_custom_target(build_kmsystemproxy DEPENDS ${GENERATED_FILE_PREFIX_ASYNC}.a)

=== ok/CMakeLists.txt ===

add_subdirectory(engine)
# add_subdirectory(loader)

=== ok/engine/CMakeLists.txt ===
#
# Copyright (c) KylinSoft  Co., Ltd. 2024. All rights reserved.
#
# kaiming is licensed under the GPL v2.0+.
# 
# See the LICENSE file for more details.
#

set(CMAKE_FIND_LIBRARY_SUFFIXES ".a")

pkg_search_module(elf_static REQUIRED IMPORTED_TARGET libelf)
# pkg_search_module(deflate_static REQUIRED IMPORTED_TARGET libdeflate)
pkg_search_module(lz4_static REQUIRED IMPORTED_TARGET liblz4)
pkg_search_module(lzma_static REQUIRED IMPORTED_TARGET liblzma)
pkg_search_module(zlib_static REQUIRED IMPORTED_TARGET zlib)
pkg_search_module(zstd_static REQUIRED IMPORTED_TARGET libzstd)
pkg_search_module(uuid_static REQUIRED IMPORTED_TARGET uuid)

# 查找库文件，V10 SP1中libdeflate-dev中没有.pc文件，不能用pkgconfig查找
find_library(FOUND_deflate_static NAMES deflate)
if("${FOUND_deflate_static}" STREQUAL "")
  message(FATAL_ERROR "libdeflate.a not fount")
endif()
get_filename_component(LIBDEFLATE_ABS_FILE ${FOUND_deflate_static} ABSOLUTE)
message(STATUS "found libdeflate.a: ${LIBDEFLATE_ABS_FILE}")

# 查找头文件路径
find_path(deflate_static_INCLUDE_DIRS NAMES libdeflate.h)
if (NOT deflate_static_INCLUDE_DIRS)
    message(FATAL_ERROR "Could not find libdeflate.h")
endif()
message(STATUS "Found libdeflate.h at: ${deflate_static_INCLUDE_DIRS}")

add_link_options(-static -static-libgcc -static-libstdc++)

set(ONLY_TO_TERMINAL 1)
configure_file(config.h.in config.h)

add_executable(ok-engine
    main.cpp
    KMOABApplication.h
    KMOABApplication.cpp
    KMOABContext.h
    KMOABElf.h
    KMOABElf.cpp
    KMOABExtract.h
    KMOABExtract.cpp
    KMOABPrintMeta.h
    KMOABPrintMeta.cpp
    KMOABUtils.h
    KMOABUtils.cpp
    KMOABRepackage.h
    KMOABRepackage.cpp
    KMOABPrintDataDir.h
    KMOABPrintDataDir.cpp
    KMOABMount.h
    KMOABMount.cpp
    KMOABRun.h
    KMOABRun.cpp
    ../../common/KMBuildinOptions.h
    ../../common/KMBuildinOptions.cpp
    ../../common/KMException.h
    ../../common/KMException.cpp
    ../../common/KMObject.h
    ../../common/KMObject.cpp
    ../../common/KMSingleton.h
    ../../common/KMSubCommand.h
    ../../common/KMSubCommand.cpp
    ../../common/KMDynamicCreator.h
    ../../common/KMDynamicCreator.cpp
    ../../common/KMOABMetadata.h
    ../../common/KMOABMetadata.cpp
    ../../common/KMStringUtils.h
    ../../common/KMStringUtils.cpp
    ../../common/KMJsonHelper.h
    ../../common/KMJsonHelper.cpp
    ../../common/KMInfoJson.h
    ../../common/KMInfoJson.cpp
    ../../common/KMLogger.h
    ../../common/KMLogger.cpp
    ../../common/KMConfigData.h
    ../../common/KMCrun.h
    ../../common/KMCrun.cpp
    ../../common/KMContainer.h
    ../../common/KMContainer.cpp
)

target_include_directories(ok-engine PRIVATE 
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${elf_static_INCLUDE_DIRS}
    ${deflate_static_INCLUDE_DIRS}
    ${lz4_static_INCLUDE_DIRS}
    ${lzma_static_INCLUDE_DIRS}
    ${zlib_static_INCLUDE_DIRS}
    ${zstd_static_INCLUDE_DIRS}
    ${uuid_static_INCLUDE_DIRS}
)

target_link_libraries(ok-engine PUBLIC
    # ${elf_static_LIBRARIES}
    PkgConfig::elf_static
    # PkgConfig::deflate_static
    ${LIBDEFLATE_ABS_FILE}
    PkgConfig::lz4_static
    PkgConfig::lzma_static
    PkgConfig::zlib_static
    PkgConfig::zstd_static
    PkgConfig::uuid_static
    stdc++fs
)

install( TARGETS ok-engine
    RUNTIME DESTINATION  /opt/kaiming-tools/bin
)

=== test/cpptest/CMakeLists.txt ===
#
# Copyright (c) KylinSoft  Co., Ltd. 2024. All rights reserved.
#
# kaiming is licensed under the GPL v2.0+.
# 
# See the LICENSE file for more details.
#

cmake_minimum_required(VERSION 3.5 FATAL_ERROR)
project(UnitTests)

set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} -fprofile-arcs -ftest-coverage")

set(ONLY_TO_TERMINAL 1)
configure_file(config.h.in config.h)

# 查找GTest
find_package(GTest REQUIRED)

# 源文件目录
aux_source_directory(app TEST_SRC_APP)
aux_source_directory(common TEST_SRC_COMMON)
aux_source_directory(ok TEST_SRC_OK)
aux_source_directory(../../app/builder OUTER_SRC_BUILDER)

# 添加你的源文件
add_executable(kmtest
        main.cpp
        ${TEST_SRC_APP}
        ${TEST_SRC_COMMON}
        ${TEST_SRC_OK}
        ${OUTER_SRC_BUILDER}
        ../../ok/engine/KMOABElf.cpp
        ../../ok/engine/KMOABExtract.cpp
        ../../ok/engine/KMOABPrintMeta.cpp
        ../../ok/engine/KMOABUtils.cpp
        ../../ok/engine/KMOABRepackage.cpp
        ../../ok/engine/KMOABPrintDataDir.cpp
        ../../ok/engine/KMOABMount.cpp
        ../../ok/engine/KMOABRun.cpp
        )

# 包含GTest头文件
target_include_directories(kmtest PRIVATE 
    ${CMAKE_CURRENT_SOURCE_DIR}
    ${CMAKE_CURRENT_SOURCE_DIR}/../../
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/run
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/install
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/search
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/uninstall
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/update
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/kill
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/info
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/list
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/repair
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/ps
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/builder
    ${CMAKE_CURRENT_SOURCE_DIR}/../../ok/engine
    ${CMAKE_CURRENT_SOURCE_DIR}/../../app/enter
    ${CMAKE_CURRENT_SOURCE_DIR}/../../common
    ${GTEST_INCLUDE_DIRS}
)

# 链接GTest库到你的可执行文件
target_link_libraries(kmtest PUBLIC  
    kaiming-common
    ${GTEST_LIBRARIES}
    pthread
)

=== debian/changelog ===
kaiming (1.0.0-ok1k0.7) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.处理打印信息
                  2.解决批量安装时只umount一次问题
                  3.xdg功能 dbus v11/no v11路径适配
                  4.处理服务类应用字段
                  5.id命名规则放宽松
  * 其他改动影响域: 安装、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 07 May 2025 10:23:16 +0800

kaiming (1.0.0-ok1k0.6) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.修复快捷方式启动开明应用的问题
                  2.app间调用
                  3.v10sp1适配
                  4.处理服务类应用文件路径
                  5.处理网页应用图标
                  6.修复gsettings获取值错误问题
  * 其他改动影响域: 构建、安装、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Sun, 04 May 2025 19:23:02 +0800

kaiming (1.0.0-ok1k0.5) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 1.兼容depends列表中包含空串的场景
                  2.crun分离及删除应用结束后的目录
                  3.增加xdgopen、网络、蓝牙权限到构建环境
                  4.增加polkit配置，以方便构建时安装依赖
                  5.kaiming build-init时安装依赖的方式替换
                  6.kaiming run分离引起构建问题修改
  * 其他改动影响域: 构建、运行 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 28 Apr 2025 17:02:40 +0800

kaiming (1.0.0-ok1k0.4) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:
    修改计算包大小的方式;更换md5sum的方案;修复/opt/kaiming为空时，update报段错误的问题;处理默认版本解析错误
  * 其他改动影响域: kaiming build-export 

 -- zhaominyong <zhaominyong@kylinos.cn>  Tue, 22 Apr 2025 16:11:31 +0800

kaiming (1.0.0-ok1k0.3) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 优化kaiming run启动时间；修复kaiming which问题
  * 其他改动影响域: kaiming which; kaiming run; 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 16 Apr 2025 16:35:16 +0800

kaiming (1.0.0-ok1k0.2) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 修改下载源时curl设置的链接超时
  * 其他改动影响域: 无 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 17:28:13 +0800

kaiming (1.0.0-ok1k0.1) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: CI构建，版本增加规则
  * 其他改动影响域: 无 

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 22:20:26 +0800

kaiming (1.0.0-ok1k0.0) v11-2603-preview; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 准备发布，初始化版本号
  * 其他改动影响域: 无

 -- zhaominyong <zhaominyong@kylinos.cn>  Mon, 14 Apr 2025 21:33:24 +0800

kaiming (0.90.1-ok0.2k0.31) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:
    添加KSAF和执行控制标记；卸载runtime/base时，打印将要被卸载的软件包;build-init安装base\runtime成功后数组越界问题
  * 其他改动影响域: kaiming install、uninstall

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Thu, 10 Apr 2025 16:13:57 +0800

kaiming (0.90.1-ok0.2k0.30) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: kaiming init自动安装依赖越界问题修改
  * 其他改动影响域: kaiming包构建 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 09 Apr 2025 18:04:58 +0800

kaiming (0.90.1-ok0.2k0.29) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 无法在线安装devel包；安装base包卡住问题
  * 其他改动影响域: kaiming install 

 -- zhaominyong <zhaominyong@kylinos.cn>  Wed, 09 Apr 2025 16:18:12 +0800

kaiming (0.90.1-ok0.2k0.28) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: kwre部署后删除files目录；优化kaiming info模块；递归卸载依赖软件时，补充kwre应用卸载逻辑
  * 其他改动影响域: kaiming install;kaiming info等

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Wed, 07 Apr 2025 10:28:01 +0800

kaiming (0.90.1-ok0.2k0.27) v11-2503; urgency=medium

  * BUG: 修改kwre部署文件删除逻辑，修复base文件无法删除问题
  * 任务: 新增which模块，用于搜索指定文件属于哪个软件包
  * 需求: [448097] 新增功能 kaiming which ，查询文件所属哪个包
  * 其他改动说明:
  * 其他改动影响域:

 -- caoxiansheng <caoxiansheng@kylinos.cn>  Wed, 02 Apr 2025 09:56:44 +0800

kaiming (0.90.1-ok0.2k0.26) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 自包含sw_64适配改造
  * 其他改动影响域: sw_64架构

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 30 Mar 2025 10:10:30 +0800
 

kaiming (0.90.1-ok0.2k0.25) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 简化yaml编写
  * 其他改动影响域: 构建、运行

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 27 Mar 2025 01:53:17 +0800

kaiming (0.90.1-ok0.2k0.24) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 自包含loong64适配改造
  * 其他改动影响域: loong64架构

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 24 Mar 2025 17:48:13 +0800

kaiming (0.90.1-ok0.2k0.23) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: loong64适配改造
  * 其他改动影响域: loong64架构

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 20 Mar 2025 20:21:45 +0800

kaiming (0.90.1-ok0.2k0.22) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明:  完善开明分离功能
  * 其他改动影响域: 暂无

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 17 Mar 2025 17:24:59 +0800

kaiming (0.90.1-ok0.2k0.21) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 开明自包含功能
  * 其他改动影响域: 暂无

 -- luchaoyang <luchaoyang@kylinos.cn>  Fri, 14 Mar 2025 13:34:50 +0800

kaiming (0.90.1-ok0.2k0.20) v11-2503; urgency=medium

  * BUG: 332587 安全编译选项检查结果中，kaiming存在安全编译风险项
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 暂无
  * 其他改动影响域: 暂无

 -- zhaominyong <zhaominyong@kylinos.cn>  Thu, 06 Mar 2025 19:15:31 +0800

kaiming (0.90.1-ok0.2k0.19) v11-2503; urgency=medium

  * BUG:  #330342 【开明】  执行kaiming run 命令提示错误
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 使用过程中发现的一些问题修复或优化
  * 其他改动影响域: 开明包使用

 -- luchaoyang <luchaoyang@kylinos.cn>  Mon, 24 Feb 2025 15:53:27 +0800

kaiming (0.90.1-ok0.2k0.18) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 使用过程中发现的一些问题修复或优化
  * 其他改动影响域: 开明包使用

 -- yushuoqi <yushuoqi@kylinos.cn>  Wed, 12 Feb 2025 16:48:27 +0800

kaiming (0.90.1-ok0.2k0.17) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 版本号3段是在线安装不上
  * 其他改动影响域: 开明包在线安装

 -- zhaominyong <zhaominyong@kylinos.cn>  Fri, 24 Jan 2025 16:07:02 +0800

kaiming (0.90.1-ok0.2k0.16) v11-2503; urgency=medium

  * BUG: 无
  * 任务: 无
  * 需求: 无
  * 其他改动说明: 新的base、runtime中bin等目录换成了软连接，需要注释部分代码
  * 其他改动影响域: 构建

 -- zhaominyong <zhaominyong@kylinos.cn>  Fri, 17 Jan 2025 17:11:36 +0800

kaiming (0.90.1-ok0.2k0.15) v11-2503; urgency=medium

  * BUG: 无


=== debian/control ===
Source: kaiming
Section: admin
Priority: optional
Maintainer: Kaiming Maintenance Team <yushuoqi@kylinos.cn>
Uploaders:
    luchaoyang <luchaoyang@kylinos.cn>,
    yushuoqi <yushuoqi@kylinos.cn>,
    liucong <liucong1@kylinos.cn>,
    zhaominyong <zhaominyong@kylinos.cn>,
Build-Depends:
        debhelper (>= 9),
        build-essential,
        libglib2.0-dev,
        libostree-dev (>= 2020.8),
        libxml2-dev (>= 2.4),
        pkg-config,
        cmake,
        ninja-build,
        libdbus-glib-1-dev,
        nlohmann-json3-dev,
        libdbus-1-dev,
        libcurl4-gnutls-dev,
        zlib1g-dev,
        libelf-dev,
        liblz4-dev,
        liblzma-dev,
        libdeflate-dev,
        libzstd-dev,
        uuid-dev,
        libgtest-dev,
        crun,
        libyajl-dev,
        patchelf
Standards-Version: 4.6.2
Homepage: https://gitee.com/openkylin/community/tree/master/sig/KaiMing
Vcs-Git: https://gitee.com/openkylin/kaiming.git
Vcs-Browser: https://gitee.com/openkylin/kaiming
Rules-Requires-Root: no

Package: kaiming
Architecture: linux-any
Depends:
        adduser,
        rsync,
        ${misc:Depends},
Description: Application deployment framework for desktop apps

=== debian/rules ===
#!/usr/bin/make -f
# See debhelper(7) (uncomment to enable)
# output every command that modifies files on the build system.

export DH_VERBOSE = 1
export DEB_BUILD_OPTIONS = nocheck # Avoid dh_auto_test check


%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- "-GNinja"

override_dh_auto_build:
	dh_auto_build -- -j8

# 重写 dh_auto_install
override_dh_auto_install:
	dh_auto_install
	# 调用脚本收集二进制依赖库
	mkdir -p debian/kaiming/opt/kaiming-tools/lib/
	# 进行依赖复制和rpath设置
	./shells/bundle_dependencies.sh

override_dh_shlibdeps:
	dh_shlibdeps --dpkg-shlibdeps-params=--ignore-missing-info -- -l/opt/kaiming-tools/lib

override_dh_installdocs:

override_dh_installchangelogs:
